<template>
    <v-chart ref="echart" :options="chart_options" autoresize></v-chart>
</template>

<script>
import chart_colors from "./chart_colors";

export default {
    name: "TopEChart",
    props: {
        chart_data: Array
    },
    watch: {
        chart_data(data){
            if(Array.isArray(this.chart_data) && this.chart_data.length){
                this.setChartData(this.chart_data);
            }
        }
    },
    data(){
        return {
            chart_options: {
                legend: {
                    show: true,
                    orient: 'horizontal',
                    align: "left",
                    top: 160,
                    width: 2,
                    left: 'center',
                    icon: 'circle',
                    selectedMode: false,
                    textStyle: {
                        color: '#aab2b7',
                        fontFamily: 'Geometria',
                        lineHeight: 8,
						align: 'center',
                    },
                },
                series: [
                    {
                        name: 'chart',
                        type: 'pie',
                        top: 0,
                        left: '10%',
                        right: '10%',
                        width: 'auto',
                        height: 150,
                        hoverOffset: 5,
                        startAngle: 90,
                        clockwise: true,
                        radius: ['55%', '90%'],
                        center: ['50%', 80],
                        label: {
                            show: false,
                            position: 'center',
                        },
                        emphasis: {
                            label: {
                                show: true,
                                fontSize: 13,
                                color: '#aab2b7',
                                formatter: (params) => {
                                    return params.name + '\n' + Number.parseFloat(params.value).toFixed(2) + '$ \n' + params.percent + '%';
                                },
                            }
                        },
                        itemStyle: {
                            //borderRadius: 20 //Only 5.0 feature and not supported position
                        },
                        data: [
                            {
                                value: 2,
                                name: 'a',
                            },
                            {
                                value: 2,
                                name: 'b',
                            },
                            {
                                value: 2,
                                name: 'c',
                            },
                            {
                                value: 1,
                                name: '',
                                itemStyle: {
                                    color: '#f9f9f9'
                                }
                            },
                        ]
                    }
                ],
                color: chart_colors.default_gradients
            }
        }
    },
    methods: {
        setChartData(data){
            this.chart_options.series[0].data = data;
        }
    },
    mounted() {
        if(Array.isArray(this.chart_data) && this.chart_data.length){
            this.setChartData(this.chart_data);
        }
    }
}
</script>

<style scoped>
.echarts {
    width: 100%;
	min-height: 300px;
	max-height: 300px;
	height: 100%;
}
</style>
